Bug 1209151 - one finger tap registers as two or three finger tap
Summary: one finger tap registers as two or three finger tap
Keywords:
Status: CLOSED CURRENTRELEASE
Alias: None
Product: Fedora
Classification: Fedora
Component: libinput
Version: 22
Hardware: Unspecified
OS: Linux
low
medium
Target Milestone: ---
Assignee: Peter Hutterer
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2015-04-06 13:16 UTC by Jeff Bastian
Modified: 2016-05-05 05:52 UTC (History)
4 users (show)

Fixed In Version: libinput-0.13.0-6.fc22
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2016-05-05 05:52:54 UTC
Type: Bug


Attachments (Terms of Use)
x-session log (444.23 KB, text/plain)
2015-04-06 13:21 UTC, Jeff Bastian
no flags Details
evemu-record output (342.05 KB, text/plain)
2015-04-07 12:45 UTC, Jeff Bastian
no flags Details
3 finger tap being seen as 2 (17.35 KB, text/plain)
2015-04-15 19:27 UTC, Kevin Fenzi
no flags Details

Description Jeff Bastian 2015-04-06 13:16:43 UTC
Description of problem:
Occasionally a one-finger tap (i.e. left-click) registers as a two-finger (i.e., right-click) or three-finger (i.e., middle-click) tap.  For example, I try to click a link in Firefox by tapping with one finger, but the right-click context menu appears.  Or I try to tap-and-drag to select text in gnome-terminal but it instead pastes unwanted text in the terminal.

I see some errors in my logs:

~]$ journalctl -b 0 _COMM=gdm-x-session -o cat | grep libinput.bug
(EE) libinput bug: unexpected scroll event 0 in area state
(EE) libinput bug: unexpected scroll event 0 in area state
(EE) libinput bug: unexpected scroll event 0 in area state
(EE) libinput bug: invalid event, no fingers are down
(EE) libinput bug: unexpected scroll event 0 in area state
(EE) libinput bug: unexpected scroll event 0 in area state
(EE) libinput bug: invalid event when fingers are up
(EE) libinput bug: invalid event when fingers are up
(EE) libinput bug: invalid event when fingers are up
(EE) libinput bug: unexpected scroll event 0 in area state
(EE) libinput bug: unexpected scroll event 0 in area state
(EE) libinput bug: invalid event, no fingers are down
(EE) libinput bug: unexpected scroll event 0 in area state
(EE) libinput bug: unexpected scroll event 0 in area state
(EE) libinput bug: invalid event, no fingers are down
(EE) libinput bug: unexpected scroll event 0 in area state
(EE) libinput bug: unexpected scroll event 0 in area state
(EE) libinput bug: invalid event, no fingers are down
(EE) libinput bug: unexpected scroll event 0 in area state
(EE) libinput bug: unexpected scroll event 0 in area state
...


Version-Release number of selected component (if applicable):
libinput-0.13.0-1.fc22.x86_64
xorg-x11-drv-libinput-0.8.0-2.fc22.x86_64
xorg-x11-server-Xorg-1.17.1-7.fc22.x86_64
xorg-x11-server-Xwayland-1.17.1-7.fc22.x86_64
gnome-shell-3.16.0-1.fc22.x86_64

How reproducible:
unknown

Steps to Reproduce:
1. tap to click things

Actual results:
sometimes single-finger taps work like two- or three-finger taps

Expected results:
single-finger tap is always a left-click

Additional info:

Comment 1 Jeff Bastian 2015-04-06 13:21:53 UTC
Created attachment 1011382 [details]
x-session log

Comment 2 Peter Hutterer 2015-04-07 07:05:41 UTC
pls record your device with evemu-record and attach the output here. This should help narrow down where the problem is. For bugs that are only seen occasionally, please try to keep the recording as short as possible.

http://www.freedesktop.org/wiki/Evemu

Comment 3 Jeff Bastian 2015-04-07 12:45:14 UTC
Created attachment 1011747 [details]
evemu-record output

The buttons started acting weird about 8 or 9 seconds into this recording.

Comment 4 Jeff Bastian 2015-04-07 13:02:08 UTC
It feels like an off-by-1 error: I was using the KDE System Settings -> Input Devices tool where you can click on a testing area and it tells you which button you clicked.  When it starts acting up, I noticed a single-finger-tap shows up as a right-click, and a double-finger-tap was a middle-click.  So it seems like the libinput driver forgot to subtract 1 from the number of fingers on a tap-release event, and thus the next tap registers as fingers+1.

Comment 5 Peter Hutterer 2015-04-08 05:21:21 UTC
Verified, filed this upstream here: https://bugs.freedesktop.org/show_bug.cgi?id=89949

Comment 6 Peter Hutterer 2015-04-08 07:11:04 UTC
Scratch build for testing available here, does this fix the issue?
http://koji.fedoraproject.org/koji/taskinfo?taskID=9434244

Comment 7 Jeff Bastian 2015-04-08 13:19:32 UTC
The scratch build works great!  Thanks!

Comment 8 Fedora Update System 2015-04-08 22:05:09 UTC
libinput-0.13.0-4.fc22 has been submitted as an update for Fedora 22.
https://admin.fedoraproject.org/updates/libinput-0.13.0-4.fc22

Comment 9 Fedora Update System 2015-04-09 16:46:01 UTC
Package libinput-0.13.0-4.fc22:
* should fix your issue,
* was pushed to the Fedora 22 testing repository,
* should be available at your local mirror within two days.
Update it with:
# su -c 'yum update --enablerepo=updates-testing libinput-0.13.0-4.fc22'
as soon as you are able to.
Please go to the following url:
https://admin.fedoraproject.org/updates/FEDORA-2015-5900/libinput-0.13.0-4.fc22
then log in and leave karma (feedback).

Comment 10 Kevin Fenzi 2015-04-15 19:27:08 UTC
This change seems to completely break 3 finger tap here. 

I can't get it to ever see 3 fingers, it always sees it as 2. 

will attach evemu record

Comment 11 Kevin Fenzi 2015-04-15 19:27:44 UTC
Created attachment 1014925 [details]
3 finger tap being seen as 2

Comment 12 Kevin Fenzi 2015-04-15 19:42:59 UTC
Sorry for the noise here. This seems to be a kernel issue. Works with 4.0.0, breaks with the 4.1.x pre rc ones in rawhide. Will file a new bug for that.

Comment 13 Peter Hutterer 2015-04-16 00:14:26 UTC
See Bug 1212230 for Kevin's issue, it is unrelated to this one.

Comment 14 Fedora Update System 2015-04-17 00:34:56 UTC
libinput-0.13.0-6.fc22 has been submitted as an update for Fedora 22.
https://admin.fedoraproject.org/updates/libinput-0.13.0-6.fc22

Comment 15 Fedora Update System 2015-04-22 22:46:27 UTC
libinput-0.13.0-6.fc22 has been pushed to the Fedora 22 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 16 Peter Hutterer 2016-05-05 05:52:54 UTC
this bug should've been auto-closed but didn't.


Note You need to log in before you can comment on or make changes to this bug.